public class Boids {
  ArrayList boids;

  public Boids() {
    boids = new ArrayList();
  }  

  int size() {
    return boids.size();  
  }

  void addBoid() {
    boids.add(new Boid(new Vector(width/2, height/2)));     
  }

  void addBoid(Vector v) {
    boids.add(new Boid(v));  
  }

  void draw() {
    Boid boid;
    for (int i=0; i<boids.size(); i++) {
      boid = (Boid) boids.get(i);
      boid.draw();    
    }     
  }

  void step() {
    update();
    move();
  }

  void update() {
    Boid boid;

    for (int i=0; i<boids.size(); i++) {
      boid = (Boid) boids.get(i);
      boid.resetInfluences();
    }

    for (int i=0; i<boids.size(); i++) {
      boid = (Boid) boids.get(i);

      for (int j=0; j<boids.size(); j++) {
        if (i == j) continue;
        boid.calcBoidBoidInfluences((Boid) boids.get(j));
      }

      boid.calcBoidEnvironmentInfluences();

      boid.applyInfluences();
    }
  }


  void move() {
    Boid boid;
    for (int i=0; i<boids.size(); i++) {
      boid = (Boid) boids.get(i);
      boid.step();    
    }       
  }

  void removeAll() {
    boids.clear();  
  }

  void setVelocity(Vector v) {
    Boid b;
    for (int i=0; i<boids.size(); i++) {
      b = (Boid) boids.get(i);
      b.velocity = v.copy();
    }  
  }

  void addInfluence(Vector v) {
    Boid b;
    for (int i=0; i<boids.size(); i++) {
      b = (Boid) boids.get(i);
      b.velocity.add(v);
    }  
  }
}




